package org.servicemix.components.xfire;

import javax.jbi.messaging.ExchangeStatus;
import javax.jbi.messaging.MessageExchange;
import javax.jbi.messaging.MessagingException;
import javax.jbi.messaging.NormalizedMessage;
import javax.xml.stream.XMLStreamReader;

import org.codehaus.xfire.MessageContext;
import org.codehaus.xfire.XFire;
import org.codehaus.xfire.exchange.InMessage;
import org.codehaus.xfire.transport.Channel;
import org.codehaus.xfire.transport.Transport;
import org.codehaus.xfire.transport.local.LocalTransport;
import org.servicemix.jbi.binding.OutBinding;

public class XFireOutBinding extends OutBinding {
    private XMarshaler marshaller;

    private XFire xfire;

    public XFireOutBinding()
    {
        super();

        this.marshaller = new XMarshaler();
    }
    
    protected void process(MessageExchange messageExchange, NormalizedMessage nm)
            throws MessagingException {
        try {
            XMLStreamReader reader = marshaller.createStreamReader(nm);

            InMessage in = new InMessage(reader, "");
            MessageContext context = new MessageContext();
            context.setXFire(xfire);
            context.setService(xfire.getServiceRegistry().getService(getService().getLocalPart()));

            Transport transport = 
                xfire.getTransportManager().getTransport(LocalTransport.NAME);
            Channel channel = transport.createChannel();
            channel.receive(context, in);

            done(messageExchange);
        } catch (Exception e) {
            fail(messageExchange, e);
        }
    }

    public XFire getXfire() {
        return xfire;
    }

    public void setXfire(XFire xfire) {
        this.xfire = xfire;
    }
}
